import "core-js/modules/es6.regexp.search";
import "core-js/modules/es6.object.set-prototype-of";

var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

import * as React from 'react';
import './index.css';
import iframeDecorator from '../IframeDecorator';
import { getItalentFeedUrl, getToUserId } from '../helper';
import FeedSetting from '../components/pageBuilder/PropsCollection/FeedSetting';

var Feed =
/** @class */
function (_super) {
  __extends(Feed, _super);

  function Feed() {
    var _this = _super !== null && _super.apply(this, arguments) || this;

    _this.getId = function (channels, ids) {
      channels.map(function (data, index) {
        data.checked && ids.push(data.id);
        data.subChannels && _this.getId(data.subChannels, ids);
      });
      return ids;
    }; // resetHeight=()=>{
    //     if(this.ifreamRef){
    //         this.ifreamRef.style.height = this.ifreamRef.height;
    //     }
    // }
    // componentDidMount(){
    //     this.resetHeight()
    // }
    // componentDidUpdate(){
    //     this.resetHeight()
    // }


    _this.fixUrl = function (url) {
      var FeedValue = _this.props.data.FeedValue;
      url += "&to_user=" + getToUserId();
      if (!FeedValue) return url;
      var publish = FeedValue.publish,
          search = FeedValue.search,
          channel = FeedValue.channel,
          channels = FeedValue.channels,
          at = FeedValue.at;
      url += "&publish=" + publish + "&search=" + search + "&channel=" + channel + "&at=" + at + "&channels=" + _this.getId(channels, []);
      return url;
    };

    return _this;
  }

  Feed.getEditProps = function () {
    return [{
      pType: FeedSetting,
      name: '设置',
      key: 'FeedValue'
    }];
  };

  Feed.prototype.render = function () {
    var _this = this;

    var feedUrl = this.fixUrl(getItalentFeedUrl());
    return iframeDecorator(this.props.mode)(React.createElement("div", {
      className: 'feed-wrapper'
    }, React.createElement("iframe", {
      scrolling: 'no',
      ref: function ref(refs) {
        _this.ifreamRef = refs;
      },
      style: {
        minWidth: '20px'
      },
      src: feedUrl,
      id: 'iTalentFrame',
      className: 'iTalent-frame',
      frameBorder: '0'
    }, " ")));
  };

  Feed.displayTitle = '动态';
  return Feed;
}(React.PureComponent);

export default Feed;