import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import "core-js/modules/es6.array.fill";
import React from "react";
import "./index.css";
import Header from "../../../components/common/componentHeader";
import ChartBase from "../../../components/common/rechartBase";
import NoData from "../../../components/common/noDataView";
import * as Rechart from 'recharts'; //自定义轴线

var CustomizedAxisTick = function CustomizedAxisTick(_ref) {
  var pos = _ref.pos,
      x = _ref.x,
      y = _ref.y,
      stroke = _ref.stroke,
      payload = _ref.payload,
      unit = _ref.unit,
      textColor = _ref.textColor;
  return React.createElement("g", {
    transform: "translate(".concat(x, ",").concat(y, ")")
  }, React.createElement("text", {
    x: pos.x,
    y: pos.y,
    textAnchor: "end",
    fill: textColor
  }, payload.value, unit || ""));
}; //内容区


function SimpleAreaChart(_ref2) {
  var CustomTooltip = _ref2.CustomTooltip,
      xKey = _ref2.xKey,
      data = _ref2.data,
      fill = _ref2.fill,
      unit = _ref2.unit,
      stroke = _ref2.stroke,
      textColor = _ref2.textColor,
      rechart = _ref2.rechart;
  var ResponsiveContainer = rechart.ResponsiveContainer,
      AreaChart = rechart.AreaChart,
      XAxis = rechart.XAxis,
      CartesianGrid = rechart.CartesianGrid,
      Tooltip = rechart.Tooltip,
      Area = rechart.Area;
  var toolTipCursor = {
    strokeDasharray: "2 2",
    stroke: "#1695f0",
    strokeWidth: 1
  };
  var areaDot = {
    stroke: stroke || fill,
    fill: fill,
    strokeWidth: 3,
    r: 1.5
  };
  return React.createElement(ResponsiveContainer, {
    width: "100%",
    height: "100%",
    minWidth: 150,
    minHeight: 100
  }, React.createElement(AreaChart, {
    data: data,
    margin: {
      right: 0,
      left: 0
    }
  }, React.createElement(XAxis, {
    padding: {
      left: 0,
      right: 0
    },
    tick: React.createElement(CustomizedAxisTick, {
      pos: {
        x: 15,
        y: -6
      },
      textColor: textColor
    }),
    stroke: "#acb7bf",
    tickLine: false,
    height: 46,
    mirror: true,
    dataKey: xKey,
    interval: 0
  }), React.createElement(CartesianGrid, {
    strokeDasharray: "2 2",
    stroke: "#e4ebf0",
    horizontal: false,
    vertical: true
  }), React.createElement(Tooltip, {
    active: true,
    offset: 10,
    animationDuration: 200,
    content: React.createElement(CustomTooltip, null),
    cursor: toolTipCursor
  }), React.createElement(Area, {
    dot: areaDot,
    activeDot: {
      strokeWidth: 3,
      r: 7
    },
    type: "monotone",
    dataKey: "value",
    stroke: stroke || fill,
    strokeWidth: 2,
    fillOpacity: 0.5,
    fill: fill
  })));
} //公共图表组件


var CommonAreaChart =
/*#__PURE__*/
function (_ChartBase) {
  _inherits(CommonAreaChart, _ChartBase);

  function CommonAreaChart() {
    _classCallCheck(this, CommonAreaChart);

    return _possibleConstructorReturn(this, _getPrototypeOf(CommonAreaChart).apply(this, arguments));
  }

  _createClass(CommonAreaChart, [{
    key: "render",
    value: function render() {
      if (!Rechart) return null;
      var _this$props = this.props,
          CustomTooltip = _this$props.CustomTooltip,
          xKey = _this$props.xKey,
          iconColor = _this$props.iconColor,
          areaKey = _this$props.areaKey,
          data = _this$props.data,
          color = _this$props.color,
          title = _this$props.title,
          icon = _this$props.icon,
          fill = _this$props.fill,
          unit = _this$props.unit,
          stroke = _this$props.stroke,
          textColor = _this$props.textColor;
      return React.createElement("div", {
        className: "common-area-chart"
      }, React.createElement(Header, {
        color: iconColor,
        icon: icon,
        title: title
      }), React.createElement("div", {
        className: "chart-wrapper"
      }, !data.length ? React.createElement(NoData, {
        icon: 2
      }) : React.createElement(SimpleAreaChart, {
        rechart: Rechart,
        unit: unit,
        CustomTooltip: CustomTooltip,
        xKey: xKey,
        areaKey: areaKey,
        data: data,
        stroke: stroke,
        fill: fill,
        textColor: textColor
      })));
    }
  }]);

  return CommonAreaChart;
}(ChartBase);

export { CommonAreaChart as default };