import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import React, { Component } from 'react';
import './SelectSetting.css';

var SelectSetting =
/*#__PURE__*/
function (_Component) {
  _inherits(SelectSetting, _Component);

  function SelectSetting(props) {
    var _this;

    _classCallCheck(this, SelectSetting);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SelectSetting).call(this, props));

    _this.itemSelected = function (e, index) {
      _this.props.itemSelected(_this.props.datas[index], index);

      _this.setState({
        selectIndex: index
      });

      _this.hidePop();
    };

    _this.multiItemClick = function (e, index) {
      //多选条件下，li点击，需要标记而不是update
      var datas = _this.props.datas;
      var text = _this.state.text;
      var tempText = '';

      if (index == 0) {
        tempText = datas[index].checked ? '请选择' : '全部';
      } else {
        datas.map(function (data, inde) {
          if (inde == index) {
            tempText += data.checked ? '' : data.value + ';';
          } else if (data.checked && inde != 0) {
            tempText += data.value + ';';
          }
        });
      }

      _this.setState({
        text: tempText == '' ? '全部' : tempText
      });

      _this.props.onItemSelect(_this.props.datas[index], index);
    };

    _this.multiSelectSure = function () {
      // 点击确定
      _this.props.multiSelectSure(_this.props.tabIn);

      _this.setState({
        showOptions: false
      });
    };

    _this.renderItems = function () {
      var _this$props = _this.props,
          multiSelect = _this$props.multiSelect,
          datas = _this$props.datas;
      return datas.map(function (data, index) {
        return React.createElement("li", {
          key: index,
          onClick: multiSelect ? function (e) {
            _this.multiItemClick(e, index);
          } : function (e) {
            _this.itemSelected(e, index);
          }
        }, multiSelect ? React.createElement("div", {
          className: "checkbox-wrap"
        }, React.createElement("div", {
          className: "checkbox-cover"
        }), React.createElement("input", {
          type: "checkbox",
          checked: data.checked,
          onChange: function onChange() {}
        })) : '', React.createElement("span", null, data.value));
      });
    };

    _this.showPop = function (e) {
      _this.setState({
        showOptions: true
      });

      _this.refs.popWrap.focus();
    };

    _this.hidePop = function (e) {
      _this.props.multiSelect && _this.props.multiSelectSure && _this.multiSelectSure();

      _this.setState({
        showOptions: false
      });
    };

    _this.state = {
      selectIndex: props.selectIndex || 0,
      showOptions: false,
      text: props.text || '全部'
    };
    return _this;
  }

  _createClass(SelectSetting, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          datas = _this$props2.datas,
          multiSelect = _this$props2.multiSelect,
          tabIn = _this$props2.tabIn,
          styles = _this$props2.styles;
      var _this$state = this.state,
          selectIndex = _this$state.selectIndex,
          showOptions = _this$state.showOptions;
      return React.createElement("div", {
        className: "select-setting-contain",
        onClick: function onClick(e) {
          e.stopPropagation();
          e.nativeEvent.stopPropagation();
          e.nativeEvent.stopImmediatePropagation();
        }
      }, React.createElement("div", {
        className: styles == 'outer' ? 'select-setting-title-outer' : 'select-setting-title'
      }, this.props.title), React.createElement("div", {
        className: "select-setting-body",
        style: {
          width: "calc( 100% - ".concat(this.props.title.length * 12 + 20, "px )")
        }
      }, React.createElement("div", {
        onClick: this.showPop,
        style: {
          width: '100%'
        },
        className: showOptions ? 'select-setting-selected select-setting-selected-boder ' : 'select-setting-selected'
      }, React.createElement("span", {
        className: "select-setting-contain-text"
      }, multiSelect ? this.state.text : datas[selectIndex].value), React.createElement("span", {
        className: "font-triangle-down select-setting-ico"
      })), React.createElement("div", {
        className: "options-pop-wrap",
        ref: "popWrap",
        tabIndex: tabIn,
        onBlur: this.hidePop
      }, React.createElement("ul", {
        style: {
          'display': showOptions ? 'block' : 'none'
        }
      }, this.renderItems()))));
    }
  }]);

  return SelectSetting;
}(Component);

export default SelectSetting;