import "core-js/modules/es6.function.name";
import * as React from "react";
import './avatarImg.css';
import { substring } from '../../../helper/tools';
var sizeMap = {
  20: 2,
  30: 2,
  40: 2,
  50: 6,
  60: 6,
  64: 6,
  80: 6,
  100: 8,
  120: 8,
  130: 8,
  150: 10
};
export default function AvatarImg(_a) {
  var size = _a.size,
      name = _a.name,
      src = _a.src,
      color = _a.color;
  var subName = sizeMap[size] ? substring(name, sizeMap[size], false) : name;
  var classString = 'up-avatar up-avatar_size-' + size + ' ';
  var spanObject = {
    backgroundColor: color,
    display: color ? 'inline-block' : 'none'
  };
  var imgObject = {
    display: color ? 'none' : 'inline-block',
    height: size + 'px',
    width: size + 'px',
    backgroundColor: '#79c7b7'
  };
  return React.createElement("span", {
    className: 'avatar-img-wrap',
    style: {
      display: 'inline-block',
      height: size + 'px'
    }
  }, React.createElement("img", {
    style: imgObject,
    className: classString,
    src: src
  }), React.createElement("span", {
    style: spanObject,
    className: classString
  }, " ", subName, " "));
}