import "core-js/modules/es6.object.set-prototype-of";

var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

import * as React from 'react';
import './tagFilter.css';
import { getByteLen } from '../../../helper';
import ClickOutside from 'react-click-outside';
var colors = ['#ed5858', '#f28d49', '#f5d540', '#38ba72', '#55c6c6', '#41b0d9', '#5b99ee'];

var PopArea =
/** @class */
function (_super) {
  __extends(PopArea, _super);

  function PopArea() {
    return _super !== null && _super.apply(this, arguments) || this;
  }

  PopArea.prototype.render = function () {
    var _a = this.props,
        data = _a.data,
        _onClick = _a.onClick,
        baseIndex = _a.baseIndex;
    return React.createElement("div", {
      className: 'pop-area'
    }, data.map(function (d, k) {
      return React.createElement("div", {
        className: 'pop-item',
        key: "pop-item" + k,
        onClick: function onClick() {
          _onClick(baseIndex + k);
        }
      }, d);
    }));
  };

  return PopArea;
}(React.Component);

var Filter =
/** @class */
function (_super) {
  __extends(Filter, _super);

  function Filter(p) {
    var _this = _super.call(this, p) || this;

    _this.getColor = function (selected, k) {
      if (k == 0 && selected) {
        return '#3f9cee';
      } else {
        return selected ? colors[k % 7] : '#e7eef3';
      }
    };

    _this.getOver = function () {
      //判断是否超出。
      if (_this.tags) {
        var tagData = _this.props.tagData;
        var tark = tagData.length;
        var totalWidth = _this.tags.clientWidth;
        var tempW = 0;

        for (var index = 0; index < tagData.length; index++) {
          var element = tagData[index];
          var len = getByteLen(element).len;
          tempW += len * 6 + 30;

          if (tempW > totalWidth - 45) {
            tark = index;
            break;
          }
        }

        if (tark != _this.state.tark) {
          _this.setState({
            tark: tark
          });
        }
      }
    };

    _this.showPop = function (e) {
      e.stopPropagation();
      e.nativeEvent.stopImmediatePropagation();

      _this.setState({
        showPop: true
      });
    };

    _this.closePop = function () {
      _this.setState({
        showPop: false
      });
    };

    _this.popItemClick = function (val) {
      _this.closePop();

      _this.props.handleClick(val, _this.state.tark);
    };

    _this.state = {
      showPop: false,
      popData: [],
      tark: p.tagData.length
    };
    return _this;
  }

  Filter.prototype.componentDidMount = function () {
    this.getOver();
  };

  Filter.prototype.componentDidUpdate = function () {
    this.getOver();
  };

  Filter.prototype.render = function () {
    var _this = this;

    var _a = this.props,
        tagData = _a.tagData,
        handleClick = _a.handleClick,
        selectexIndex = _a.selectexIndex;
    var _b = this.state,
        tark = _b.tark,
        showPop = _b.showPop;
    var tempData = tagData;

    if (tark < tagData.length) {
      tempData = tagData.slice(0, tark);
    }

    return React.createElement("div", {
      className: 'tagss-wrap',
      ref: function ref(refs) {
        _this.tags = refs;
      }
    }, React.createElement("div", {
      className: 'tags'
    }, tempData.map(function (text, k) {
      var selected = selectexIndex == k;
      return React.createElement("span", {
        className: 'a-tag',
        onClick: function onClick() {
          handleClick(k);
        },
        style: {
          backgroundColor: _this.getColor(selected, k),
          color: selected ? '#fff' : '#8f9ca6'
        },
        key: "a-tag" + k
      }, text);
    })), tark < tagData.length && React.createElement("div", {
      className: 'dot',
      onClick: this.showPop
    }, "..."), showPop && React.createElement(ClickOutside, {
      onClickOutside: this.closePop
    }, React.createElement(PopArea, {
      data: tagData.slice(tark),
      baseIndex: tark,
      onClick: this.popItemClick
    })));
  };

  return Filter;
}(React.Component);

export default Filter;