import "core-js/modules/es6.object.set-prototype-of";

var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

import * as React from 'react';
import './index.css';

var Input =
/** @class */
function (_super) {
  __extends(Input, _super);

  function Input(p) {
    var _this = _super.call(this, p) || this;

    _this.state = {
      value: ''
    };

    _this.handleChange = function (e) {
      _this.props.change && _this.props.change(e.target.value);

      _this.setState({
        value: e.target.value
      });
    };

    _this.handlePressEnter = function (e) {
      if (e.which === 13) {
        _this.saveState(e.currentTarget.value);
      }
    };

    _this.handleBlur = function (e) {
      _this.saveState(!e.currentTarget.value ? _this.props.defaultValue : e.currentTarget.value);

      !e.currentTarget.value && _this.setState({
        value: _this.props.defaultValue
      });
    };

    _this.state = {
      value: p.value
    };
    return _this;
  }

  Input.prototype.saveState = function (val) {
    var onChange = this.props.onChange;
    onChange && onChange(val);
  };

  Input.prototype.componentWillReceiveProps = function (props) {
    this.setState({
      value: props.value
    });
  };

  Input.prototype.render = function () {
    var placeholder = this.props.placeholder;
    return React.createElement("input", {
      className: 'cm-form-input',
      type: 'text',
      value: this.state.value || '',
      placeholder: placeholder,
      onChange: this.handleChange,
      onKeyPress: this.handlePressEnter,
      onBlur: this.handleBlur
    });
  };

  return Input;
}(React.PureComponent);

export default Input;