import "core-js/modules/es6.object.assign";
import "core-js/modules/es6.object.set-prototype-of";

var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

import * as React from 'react';

var hoistNonReactStatic = require('hoist-non-react-statics'); // import {hoistNonReactStatic} from 'hoist-non-react-statics';


function dealSize(Com, removeParentPadding) {
  var SizeProvider =
  /** @class */
  function (_super) {
    __extends(SizeProvider, _super);

    function SizeProvider() {
      var _this = _super !== null && _super.apply(this, arguments) || this;

      _this.state = {};
      return _this;
    }

    SizeProvider.prototype.componentDidMount = function () {
      if (this.anyComponent && removeParentPadding) {
        var node = this.anyComponent.parentElement;

        if (node) {
          node.style.padding = '0px';
          node.style.border = 'none';
        }
      }

      this.getSize();
    };

    SizeProvider.prototype.getSize = function () {
      var _a = this.state,
          pWidth = _a.pWidth,
          pHeight = _a.pHeight;

      if (this.anyComponent) {
        var newH = this.anyComponent.clientHeight;
        var newW = this.anyComponent.clientWidth;

        if (pWidth && pHeight && pWidth == newW && pHeight == newH) {
          return;
        } else {
          this.setState({
            pHeight: newH,
            pWidth: newW
          });
        }
      }
    };

    SizeProvider.prototype.componentDidUpdate = function () {
      this.getSize();
    };

    SizeProvider.prototype.render = function () {
      var _this = this;

      return React.createElement("div", {
        style: {
          width: '100%',
          height: '100%'
        },
        ref: function ref(anyComponent) {
          _this.anyComponent = anyComponent;
        }
      }, React.createElement(Com, __assign({}, this.props, this.state)));
    };

    return SizeProvider;
  }(React.PureComponent);

  hoistNonReactStatic(SizeProvider, Com);
  return SizeProvider;
}

export default dealSize;