import "core-js/modules/es6.function.name";
import './FeedSetting.css';
import React, { Component } from 'react';
import cn from 'classnames';
export default function ChannelSetting(_ref) {
  var data = _ref.data,
      level = _ref.level,
      pid = _ref.pid,
      _onClick = _ref.onClick,
      changeOpen = _ref.changeOpen;
  if (!data) return React.createElement("div", {
    className: "no-data"
  }); //ul

  var options = level == 1 && data.id != 50 && pid != 50;
  return React.createElement("div", {
    style: {
      marginLeft: level > 1 ? (level - 1) * 10 + 'px' : '0'
    },
    className: "channel-setting-contain"
  }, data.map(function (data, index) {
    //li
    var iconClass = {
      'channel-setting-item-icon': true,
      'font-triangle-down': true,
      'not-open': !data.open
    };
    return React.createElement("div", {
      key: index,
      className: "channel-setting-group ".concat(options ? 'have-border' : '', " ")
    }, React.createElement("div", {
      className: "channel-setting-item-wrap",
      style: {
        'display': data.id == 50 ? 'none' : 'block'
      }
    }, React.createElement("input", {
      type: "checkbox",
      defaultChecked: data.checked,
      onClick: function onClick() {
        _onClick(data);
      }
    }), React.createElement("span", {
      className: "channel-setting-item-name "
    }, data.name), data.subChannels ? React.createElement("span", {
      className: cn(iconClass),
      onClick: function onClick() {
        changeOpen(data);
      }
    }) : ''), data.open && React.createElement(ChannelSetting, {
      level: data.id == 50 ? level : level + 1,
      pid: data.id,
      onClick: _onClick,
      changeOpen: changeOpen,
      data: data.subChannels
    }));
  }));
}
;