import _regeneratorRuntime from "@babel/runtime/regenerator";
import "regenerator-runtime/runtime";
import "core-js/modules/es6.number.constructor";
import "core-js/modules/es6.promise";
import "core-js/modules/es6.regexp.match";
import "core-js/modules/es6.regexp.to-string";
import "core-js/modules/es6.object.to-string";
import "core-js/modules/es6.regexp.replace";
import "core-js/modules/es6.regexp.split";
import "core-js/modules/es6.regexp.search";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import "core-js/modules/es6.array.find";
import "core-js/modules/es6.function.name";
import objectAssign from 'object-assign';
import { debug } from 'util';
/**
 * 获取图片的完整路径
 * @return
 * //xfile4.tita.com/ux/tita-web-v5/release/dist/images/list-bg.png
 */

/*export GetStaticUrl=(url) =>{
  var staticServer = getBSGlobal('staticPath');
  return staticServer + "/images/" + url;
}*/

export function getBSGlobal(name) {
  return BSGlobal && BSGlobal[name];
}
export function GetStaticUrl(url) {
  var staticServer = getBSGlobal('staticPath');
  var staticServer = '//xfile4.tita.com/ux/uibuilder/release/extras/images';
  return staticServer + "/" + url;
} // 判断是否开通app

export function isOpenApp(appid) {
  var apps = getBSGlobal('apps') || [];
  var appItem = apps.find(function (item) {
    return item.appId == appid;
  });

  if (appItem) {
    // return true&&isOpenDoc;
    return true;
  } else {
    return false;
  }
}
export function taker(_x, _x2, _x3) {
  return _taker.apply(this, arguments);
}

function _taker() {
  _taker = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee(url, method, body) {
    var settings, response, data;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            settings = {};

            if (method) {
              settings.headers = {
                'Accept': 'application/json, application/xml, text/play, text/html, *.*',
                'Content-Type': 'application/json; charset=utf-8'
              };
              settings.method = method;
            }

            if (body) settings.body = JSON.stringify(body);
            settings.credentials = 'same-origin';
            _context.prev = 4;
            _context.next = 7;
            return fetch(url, settings);

          case 7:
            response = _context.sent;
            _context.next = 10;
            return response.json();

          case 10:
            data = _context.sent;
            return _context.abrupt("return", data);

          case 14:
            _context.prev = 14;
            _context.t0 = _context["catch"](4);
            _context.next = 18;
            return Promise.reject('出错了');

          case 18:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[4, 14]]);
  }));
  return _taker.apply(this, arguments);
}

export function takerCloud(_x4, _x5, _x6) {
  return _takerCloud.apply(this, arguments);
}
/**
 * 获取租户信息
 * @return
 * {"Id":200605,"Name":"wg","Domain":"abc.com","Abbreviation":"wg"}
 */

function _takerCloud() {
  _takerCloud = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee2(url, method, body) {
    var settings, response, data;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            settings = {};

            if (method) {
              settings.headers = {
                'Accept': 'application/json, application/xml, text/play, text/html, *.*',
                'Content-Type': 'application/json; charset=utf-8'
              };
              settings.method = method;
            }

            if (body) settings.body = JSON.stringify(body);
            settings.credentials = 'include';
            _context2.prev = 4;
            _context2.next = 7;
            return fetch(url, settings);

          case 7:
            response = _context2.sent;
            _context2.next = 10;
            return response.json();

          case 10:
            data = _context2.sent;
            return _context2.abrupt("return", data);

          case 14:
            _context2.prev = 14;
            _context2.t0 = _context2["catch"](4);
            _context2.next = 18;
            return Promise.reject('出错了');

          case 18:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[4, 14]]);
  }));
  return _takerCloud.apply(this, arguments);
}

export function getTenantInfo(url) {
  return getBSGlobal('tenantInfo');
}
/**
 * 获取当前登录用户信息
 * @return
 * {"Email":"wg1@abc.com","Avatar":"http://st-web.tita.com/titacn/tita/common/images/default_man_small.jpg","Id":100217545,"Name":"wg","IsRoot":false,"Role":3}
 */

export function getUserInfo(url) {
  return getBSGlobal('loginUserInfo');
}
/**
 * 获取后台接口的完整路径
 * @return
 * http://www.tita.com/api/v1/110006/100055587/page
 */

export function getApiUrl(url) {
  var uid = getUserInfo().Id;
  var tid = getTenantInfo().Id;
  var apiServer = getBSGlobal('apiPath');
  return apiServer + "/api/v1/" + tid + "/" + uid + "/" + url;
}
export function getTitaExpire() {
  return BSGlobal.tenantAuthentication;
}
/**
 * 获取ITalentHome的地址
 * @return
 * http://www.tita.com/100055587/ITalentHome#home
 */

export function getItalentPathname(hash) {
  var titaHost = getBSGlobal('titaHost');
  var uid = getUserInfo().Id;
  return titaHost + '/' + uid + '/ITalentHome#' + hash;
}
/**
 * 获取后台接口的完整路径
 * @return
 * http://www.tita.com/api/v2/110006/100055587/page
 */

export function getApiUrl2(url) {
  var uid = getUserInfo().Id;
  var tid = getTenantInfo().Id;
  var apiServer = getBSGlobal('apiPath');
  return apiServer + "/api/v2/" + tid + "/" + uid + "/" + url;
}
export function getWidgetIframeUrl(url) {
  var apiServer = getBSGlobal('apiPath');
}
export function getQueryStringSearch() {
  //获取Url上的参数，以{}返回
  var hash = location.search;
  var queryObject = {};
  var markIndex = hash.indexOf("?"); // contain query string in fragments

  if (markIndex > -1) {
    // build query object
    var queryString = hash.slice(markIndex + 1);
    var queryArray = queryString.split('&');

    for (var i = 0; i < queryArray.length; i++) {
      var queryPair = queryArray[i].split('=');

      if (queryPair[0] !== '_k') {
        queryObject[queryPair[0]] = decodeURIComponent(queryPair[1]);
      }
    }
  }

  return queryObject;
}
export function getQueryString() {
  //获取Url上的参数，以{}返回
  var hash = location.hash;
  var queryObject = {};
  var markIndex = hash.indexOf("?"); // contain query string in fragments

  if (markIndex > -1) {
    // build query object
    var queryString = hash.slice(markIndex + 1);
    var queryArray = queryString.split('&');

    for (var i = 0; i < queryArray.length; i++) {
      var queryPair = queryArray[i].split('=');

      if (queryPair[0] !== '_k') {
        queryObject[queryPair[0]] = decodeURIComponent(queryPair[1]);
      }
    }
  }

  return queryObject;
}
export function getPageUrl(url, pageId, type) {
  var tenantID = getTenantInfo().Id;
  var userID = getUserInfo().Id;
  return getApiUrl(url) + '?toUserId=' + userID + '&objId=' + tenantID + '&pageId=' + pageId + '&type=' + type;
} //拼接保存页面信息接口

export function getSavePageUrl(url) {
  var tenantID = getTenantInfo().Id;
  return getApiUrl(url) + '?objType=2&objId=' + tenantID;
} //     return (components.findIndex(item => item == name) == -1) ? false : true;
// }
//遍历avaliablComponde

export function transformAvaliableCom(componentsGroup) {
  var avaliableComponent = componentsGroup.map(function (group) {
    var components = group.components.map(function (item) {
      if (item.name == 'EvaluationReports') {
        // 测评报告－临时处理
        return objectAssign({}, item, {
          displayTitle: item.title,
          data: {
            'name': item.name,
            'url': item.url,
            'logo': item.logo,
            'displayTitle': item.title
          }
        });
      } else if (item.displayMode == 1) {
        return objectAssign({}, item, {
          displayTitle: item.title
        });
      } else {
        return objectAssign({}, item, {
          name: 'CommonIframeComponent',
          displayTitle: item.title,
          data: {
            'name': item.name,
            'url': item.url,
            'logo': item.logo,
            'displayTitle': item.title
          }
        });
      }
    }); // if(group.name !== 'Ocean组件') {
    //         group.components.map(item=>{
    //         item.displayTitle =item.title
    //     });
    //     return group;
    // }
    // let components = group.components.map(item => {
    //     return objectAssign({}, item, {
    //         name: 'CommonIframeComponent',
    //         displayTitle: item.title,
    //         data: {
    //             'name': item.name,
    //             'url': item.url,
    //             'logo': item.logo,
    //             'displayTitle': item.title
    //         }
    //     })
    // })

    return objectAssign({}, group, {
      'components': components
    }); // return {
    //     'appId':group.appId,
    //     'appType':group.appType,
    //     'name': group.name,
    //     'components': components
    // }
  });
  return avaliableComponent;
} //获取动态页的页面地址

export function getItalentFeedUrl() {
  return BSGlobal.titaHost + '/widget#widget/share-tab-feed?quirkLink=true&isShowAddTag=false&isShowReward=false';
} //获取相对body的位置,并返回根节点

export function getPositionInBody(dom, classFilters) {
  var left = dom.offsetLeft,
      top = dom.offsetTop + dom.scrollTop,
      current = dom.offsetParent,
      rootDom = accessBodyElement(dom); //默认是body

  while (current != null) {
    left += current.offsetLeft;
    top += current.offsetTop;
    current = current.offsetParent;

    if (current && current.matches(classFilters)) {
      rootDom = current;
      break;
    }
  }

  return {
    left: left,
    top: top,
    rootDom: rootDom
  };
} //获取body iframe中的

export function accessBodyElement(target) {
  var parentNode = target.parentElement;

  while (parentNode && parentNode.tagName.toLowerCase() != 'body') {
    parentNode = parentNode.parentElement;
  }

  return parentNode;
} //

export function getPreviewUrl(layout) {
  if (layout == 'mobile') {
    return BSGlobal.titaHost + '/' + getUserInfo().Id + '/UIBuilder#/MobileView';
  } else {
    return BSGlobal.titaHost + '/' + getUserInfo().Id + '/UIBuilder#/SingelView';
  }
} //生成唯一的ID

export function genUid() {
  return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    var r = Math.random() * 16 | 0,
        v = c == 'x' ? r : r & 0x3 | 0x8;
    return v.toString(16);
  });
} //获取默认数据信息接口

export var getDefaultPageUrl = function getDefaultPageUrl(pageId) {
  var tenantID = getTenantInfo().Id;
  var userID = getUserInfo().Id;
  return getApiUrl('gloal/UI/page?pageid=' + pageId);
};
export var setDefaultPageUrl = function setDefaultPageUrl() {
  var tenantID = getTenantInfo().Id;
  var userID = getUserInfo().Id;
  return getApiUrl('gloal/UI/page');
};
/**选取页面模版**/
// export const getTemplate = (pageInfo, templates) => {
//     let layout = pageInfo.pageSettings.layout;
//     if (templates.hasOwnProperty(layout)) return templates[layout];
//     return templates[VERTICAL]; //为空的时候，返回vertical布局
// }

export var debounce = function () {
  return function (callback, delay) {
    var timeout;
    return function () {
      var context = this,
          args = arguments;
      clearTimeout(timeout);
      timeout = setTimeout(function () {
        callback.apply(context, args);
      }, delay);
    };
  };
}();
export var insertScript = function insertScript(url) {
  var doc = document;
  var script = doc.createElement("script");
  script.setAttribute("type", "text/javascript");
  script.setAttribute("src", url);
  doc.documentElement.appendChild(script);
};

var transToTwo = function transToTwo(string) {
  return string.toString().length == 1 ? '0' + string : string;
};

export var parseTime = function parseTime(time) {
  return transToTwo(time.getHours()) + ':' + transToTwo(time.getMinutes());
}; //mac地址检测

export var macAddressCheck = function macAddressCheck(value) {
  var temp = /[A-Fa-f0-9]{2}:[A-Fa-f0-9]{2}:[A-Fa-f0-9]{2}:[A-Fa-f0-9]{2}:[A-Fa-f0-9]{2}:[A-Fa-f0-9]{2}/;
  if (value.length != 17) return false;
  if (temp.test(value)) return true;
  return false;
}; //格式化后端给的时间

export var formatTime = function formatTime(time) {
  var arr = time.split(':');
  return transToTwo(arr[0]) + ':' + transToTwo(arr[1]);
}; //检测字符数 一个汉字两个字符

export function getByteLen(val) {
  var len = 0;
  var en = 0; //英文数

  var cn = 0; //汉字数

  for (var i = 0; i < val.length; i++) {
    var a = val.charAt(i);

    if (a.match(/[^\x00-\xff]/ig) != null) {
      len += 2;
      ++cn;
    } else {
      len += 1;
      ++en;
    }
  }

  return {
    len: len,
    en: en,
    cn: cn
  };
} //在textraea的光标处插入指定内容

export function insertTextAtPointer(textEle, insertValue) {
  var start = textEle.selectionStart;
  var preValue = textEle.value;
  return preValue.substring(0, start) + insertValue + preValue.substring(start + 1);
} //生成@人的字符串

export function generateSelectedMark(users, textEle) {
  var arr = users.map(function (item) {
    if (item.hasOwnProperty('Name')) return '[' + item.Name + ':' + item.Email + ']'; //人

    return '[' + item.DepartmentName + ':' + item.Id + ':dep_members]'; //部门
  });
  var start = textEle.selectionStart;
  var value = textEle.value;
  if (value.charAt(start - 1) == '@') return arr.join(' @');
  return '@' + arr.join(' @');
}
export function stopPropagation(event) {
  if (event && event.stopPropagation) {
    event.stopPropagation();
  } else {
    event.cancelBubble = true;
  }
}
export function dealWithLoadedFileTips(content, num) {
  var index = content.match(/分享了\d+个文件/);
  if (!index) return content + '分享了' + num + '个文件';
  if (num == 0) return content.replace(/分享了\d+个文件/, '');
  return content.replace(/分享了\d+个文件/, '分享了' + num + '个文件');
}
export function textareaAutoResizing(id, initialTextHeight) {
  var observe;
  var isInit = true;

  if (window.attachEvent) {
    observe = function observe(element, event, handler) {
      element.attachEvent('on' + event, handler);
    };
  } else {
    observe = function observe(element, event, handler) {
      element.addEventListener(event, handler, false);
    };
  }

  function init() {
    var text = document.getElementById(id);

    function resize() {
      text.style.height = 'auto';
      text.style.height = isInit ? initialTextHeight + 'px' : text.scrollHeight > initialTextHeight ? text.scrollHeight + 'px' : initialTextHeight + 'px';
      isInit = false;
    }
    /* 0-timeout to get the already changed text */


    function delayedResize() {
      window.setTimeout(resize, 0);
    }

    observe(text, 'change', resize);
    observe(text, 'cut', delayedResize);
    observe(text, 'paste', delayedResize);
    observe(text, 'drop', delayedResize);
    observe(text, 'keydown', delayedResize);
    text.focus();
    text.select();
    resize();
  }

  init();
} //生成图片文件的本地预览

export function getLocalPreview(file) {
  return new Promise(function (resolve) {
    var reader = new FileReader();

    reader.onload = function (e) {
      resolve(e.target.result);
    };

    reader.readAsDataURL(file);
  });
}
export function getHeadColorById(id) {
  var color = ['#f0c75a', '#8dc8ea', '#7eb6e0', '#a1a5ee', '#c4a1ee', '#b9cc4f', '#96bf65', '#f79c6f', '#79c7b7', '#f5b168'];

  try {
    var idInt = parseInt(id);
    return color[idInt % 10];
  } catch (error) {
    console.error(error);
  }
}
export function compareIP(ipBegin, ipEnd) {
  for (var i = 0; i < 4; i++) {
    if (Number(ipBegin[i]) > Number(ipEnd[i])) {
      return 1;
    } else if (Number(ipBegin[i]) < Number(ipEnd[i])) {
      return -1;
    }
  }

  return 0;
}

function createUrl(url, frame) {
  var apiServer = getBSGlobal('apiPath');
  var uid = getBSGlobal('loginUserInfo').Id;
  var webPath = getBSGlobal('webPath');
  var iframeBoxUrl = apiServer + '/' + uid + '/UpaasHome#' + encodeURIComponent(frame + encodeURIComponent(url));

  if (apiServer.indexOf('tita') > -1) {
    iframeBoxUrl = "".concat(apiServer, "/u/").concat(uid, "/Home#").concat(encodeURIComponent(frame + encodeURIComponent(url)));
  }

  if (apiServer.indexOf('italent') > -1) {
    iframeBoxUrl = "".concat(apiServer, "/").concat(uid, "/ITalentHome#").concat(encodeURIComponent(frame + encodeURIComponent(url)));
  }

  return iframeBoxUrl;
}

export function encodeURIFn(url) {
  return createUrl(url, 'widget/italent?iTalentFrame=');
} // 只要头部栏

export function encodeURIFnTop(url) {
  return createUrl(url, 'widget/italent-no-sidebar?iTalentFrame=');
}
export function encodeURIFnWidget(url) {
  return createUrl(url, 'widget/italent?iTalentFrameType=iframe&iTalentFrame=');
}
export function urlHead() {
  var apiServer = getBSGlobal('apiPath');
  var uid = getBSGlobal('loginUserInfo').Id;
  var webPath = getBSGlobal('webPath');
  var urlHead = '//www' + webPath + '/' + uid + '/UpaasHome';

  if (webPath.indexOf('tita') > -1) {
    urlHead = "//www.".concat(webPath, "/u/").concat(uid, "/Home");
  }

  if (webPath.indexOf('italent') > -1) {
    urlHead = "//www.".concat(webPath, "/").concat(uid, "/ITalentHome");
  }

  return urlHead;
} // 获取to_user_id

export function getToUserId() {
  var toUserId = getQueryString().to_user_id || getQueryStringSearch().to_user_id;

  if (!toUserId) {
    toUserId = getUserInfo().Id;
  }

  return toUserId;
} //修改Url上的参数，

export function changeQueryString(key, value) {
  var hash = location.hash;
  var queryObject = {};
  var markIndex = hash.indexOf("?"); // contain query string in fragments

  if (markIndex > -1) {
    // build query object
    var hashName = hash.slice(0, markIndex);
    var queryString = hash.slice(markIndex + 1);
    var queryArray = queryString.split('&');
    queryArray.forEach(function (item) {
      item = item.split('=');
      queryObject[item[0]] = item[1];
    });
    queryObject[key] = value;
    var arr = [];

    for (var name in queryObject) {
      arr.push("".concat(name, "=").concat(queryObject[name]));
    }

    location.hash = "".concat(hashName, "?").concat(arr.join('&'));
  } else {
    location.hash = hash;
  }
} //对照表：页面几等分:0:5、1:6、2:12等份

export var PARTS_MAP = {
  0: 5,
  1: 6,
  2: 12
};
export var getPageColumns = function getPageColumns(parts) {
  return PARTS_MAP[parts];
};
/**
 * 跳转勋章墙页面
 * params :targetIndex:0(已获得)，1(未获得)
 */

export var getMedalWallUrl = function getMedalWallUrl(tagetIndex) {
  var loginId = getUserInfo().Id;
  var toUserId = getToUserId();
  var iframeBoxUrl = '//www.';
  var webPath = getBSGlobal('webPath');

  if (webPath.indexOf('tita') > -1) {
    iframeBoxUrl += "".concat(webPath, "/u/").concat(loginId, "/Home#");
  }

  if (webPath.indexOf('italent') > -1) {
    iframeBoxUrl += "".concat(webPath, "/").concat(loginId, "/ITalentHome#");
  }

  if (webPath.indexOf('upaas') > -1) {
    iframeBoxUrl += "".concat(webPath, "/").concat(loginId, "/UpaasHome#");
  }

  return "".concat(iframeBoxUrl).concat(encodeURIComponent("widget/italent?iTalentFrameType=iframe&iTalentNavId=&iTalentFrame=".concat(encodeURIComponent("".concat(getBSGlobal('titaHost'), "/").concat(loginId, "/UpaasPortalPlus#/medalwall?targetTabIndex=").concat(tagetIndex, "&toUserId=").concat(getToUserId())))));
};